# -*- coding: utf-8 -*-
"""june9.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1hzrtnDQMVUKklMzppxQn4efjbCawYm6x

# Stack implementation using list
"""

# Python program to 
# demonstrate stack implementation 
# using list 


stack = [] 

# append() function to push 
# element in the stack 
stack.append('a') 
stack.append('b') 
stack.append('c') 

print('Initial stack') 
print(stack) 

# pop() fucntion to pop 
# element from stack in 
# LIFO order 
print('\nElements poped from stack:') 
print(stack.pop()) 
print(stack.pop()) 
print(stack.pop()) 

print('\nStack after elements are poped:') 
print(stack) 

# uncommenting print(stack.pop()) 
# will cause an IndexError 
# as the stack is now empty

"""#Stack implementation using collections.deque"""

# Python program to 
# demonstrate stack implementation 
# using collections.deque 


from collections import deque 

stack = deque() 

# append() function to push 
# element in the stack 
stack.append('a') 
stack.append('b') 
stack.append('c') 

print('Initial stack:') 
print(stack) 

# pop() fucntion to pop 
# element from stack in 
# LIFO order 
print('\nElements poped from stack:') 
print(stack.pop()) 
print(stack.pop()) 
print(stack.pop()) 

print('\nStack after elements are poped:') 
print(stack) 

# uncommenting print(stack.pop()) 
# will cause an IndexError 
# as the stack is now empty

"""#Stack implementation using queue module"""

# Python program to 
# demonstrate stack implementation 
# using queue module 


from queue import LifoQueue 

# Initializing a stack 
stack = LifoQueue(maxsize = 3) 

# qsize() show the number of elements 
# in the stack 
print(stack.qsize()) 

# put() function to push 
# element in the stack 
stack.put('a') 
stack.put('b') 
stack.put('c') 

print("Full: ", stack.full()) 
print("Size: ", stack.qsize()) 

# get() fucntion to pop 
# element from stack in 
# LIFO order 
print('\nElements poped from the stack') 
print(stack.get()) 
print(stack.get()) 
print(stack.get()) 

print("\nEmpty: ", stack.empty())

"""# Question 2
**Infix to Postfix Conversion, and postfix evaluation using stack.**



*  Infix to Postfix Conversion
*  postfix evaluation using stack
"""

# Python program to convert infix expression to postfix 

# Class to convert the expression 
class Conversion: 
	
	# Constructor to initialize the class variables 
	def __init__(self, capacity): 
		self.top = -1
		self.capacity = capacity 
		# This array is used a stack 
		self.array = [] 
		# Precedence setting 
		self.output = [] 
		self.precedence = {'+':1, '-':1, '*':2, '/':2, '^':3} 
	
	# check if the stack is empty 
	def isEmpty(self): 
		return True if self.top == -1 else False
	
	# Return the value of the top of the stack 
	def peek(self): 
		return self.array[-1] 
	
	# Pop the element from the stack 
	def pop(self): 
		if not self.isEmpty(): 
			self.top -= 1
			return self.array.pop() 
		else: 
			return "$"
	
	# Push the element to the stack 
	def push(self, op): 
		self.top += 1
		self.array.append(op) 

	# A utility function to check is the given character 
	# is operand 
	def isOperand(self, ch): 
		return ch.isalpha() 

	# Check if the precedence of operator is strictly 
	# less than top of stack or not 
	def notGreater(self, i): 
		try: 
			a = self.precedence[i] 
			b = self.precedence[self.peek()] 
			return True if a <= b else False
		except KeyError: 
			return False
			
	# The main function that converts given infix expression 
	# to postfix expression 
	def infixToPostfix(self, exp): 
		
		# Iterate over the expression for conversion 
		for i in exp: 
			# If the character is an operand, 
			# add it to output 
			if self.isOperand(i): 
				self.output.append(i) 
			
			# If the character is an '(', push it to stack 
			elif i == '(': 
				self.push(i) 

			# If the scanned character is an ')', pop and 
			# output from the stack until and '(' is found 
			elif i == ')': 
				while( (not self.isEmpty()) and self.peek() != '('): 
					a = self.pop() 
					self.output.append(a) 
				if (not self.isEmpty() and self.peek() != '('): 
					return -1
				else: 
					self.pop() 

			# An operator is encountered 
			else: 
				while(not self.isEmpty() and self.notGreater(i)): 
					self.output.append(self.pop()) 
				self.push(i) 

		# pop all the operator from the stack 
		while not self.isEmpty(): 
			self.output.append(self.pop()) 

		print ("".join(self.output)) 

# Driver program to test above function 
exp = "a+b*(c^d-e)^(f+g*h)-i"
obj = Conversion(len(exp)) 
obj.infixToPostfix(exp)

# Python program to evaluate value of a postfix expression 

# Class to convert the expression 
class Evaluate: 
	
	# Constructor to initialize the class variables 
	def __init__(self, capacity): 
		self.top = -1
		self.capacity = capacity 
		# This array is used a stack 
		self.array = [] 
	
	# check if the stack is empty 
	def isEmpty(self): 
		return True if self.top == -1 else False
	
	# Return the value of the top of the stack 
	def peek(self): 
		return self.array[-1] 
	
	# Pop the element from the stack 
	def pop(self): 
		if not self.isEmpty(): 
			self.top -= 1
			return self.array.pop() 
		else: 
			return "$"
	
	# Push the element to the stack 
	def push(self, op): 
		self.top += 1
		self.array.append(op) 


	# The main function that converts given infix expression 
	# to postfix expression 
	def evaluatePostfix(self, exp): 
		
		# Iterate over the expression for conversion 
		for i in exp: 
			
			# If the scanned character is an operand 
			# (number here) push it to the stack 
			if i.isdigit(): 
				self.push(i) 

			# If the scanned character is an operator, 
			# pop two elements from stack and apply it. 
			else: 
				val1 = self.pop() 
				val2 = self.pop() 
				self.push(str(eval(val2 + i + val1))) 

		return int(self.pop()) 
				

			
# Driver program to test above function 
exp = "231*+9-"
obj = Evaluate(len(exp)) 
print ("postfix evaluation: %d"%(obj.evaluatePostfix(exp)))

"""#Question 2
**Given a stack, how to reverse the elements of the stack using only stack operations (push & pop)**

**OR**

Write a program to reverse a stack using recursion. You are not allowed to use loop constructs like while, for..etc, and you can only use the following ADT functions on Stack S:
isEmpty(S)
push(S)
pop(S)
"""

# Python program to reverse a 
# stack using recursion 

# Below is a recursive function 
# that inserts an element 
# at the bottom of a stack. 
def insertAtBottom(stack, item): 
	if isEmpty(stack): 
		push(stack, item) 
	else: 
		temp = pop(stack) 
		insertAtBottom(stack, item) 
		push(stack, temp) 

# Below is the function that 
# reverses the given stack 
# using insertAtBottom() 
def reverse(stack): 
	if not isEmpty(stack): 
		temp = pop(stack) 
		reverse(stack) 
		insertAtBottom(stack, temp) 

# Below is a complete running 
# program for testing above 
# functions. 

# Function to create a stack. 
# It initializes size of stack 
# as 0 
def createStack(): 
	stack = [] 
	return stack 

# Function to check if 
# the stack is empty 
def isEmpty( stack ): 
	return len(stack) == 0

# Function to push an 
# item to stack 
def push( stack, item ): 
	stack.append( item ) 

# Function to pop an 
# item from stack 
def pop( stack ): 

	# If stack is empty 
	# then error 
	if(isEmpty( stack )): 
		print("Stack Underflow ") 
		exit(1) 

	return stack.pop() 

# Function to print the stack 
def prints(stack): 
	for i in range(len(stack)-1, -1, -1): 
		print(stack[i], end = ' ') 
	print() 

# Driver Code 

stack = createStack() 
push( stack, str(4) ) 
push( stack, str(3) ) 
push( stack, str(2) ) 
push( stack, str(1) ) 
print("Original Stack ") 
prints(stack) 

reverse(stack) 

print("Reversed Stack ") 
prints(stack)

"""# Question 3
**Given n non-negative integers representing the histogram's bar height where the width of each bar is 1, find the area of largest rectangle in the histogram. For example, consider the following histogram with 7 bars of heights {6, 2, 5, 4, 5, 1, 6}. The largest possible rectangle possible is 12 (see the below figure, the max area rectangle is highlighted in red)  Note:  Solve the problem in both complexity O(nlog) and O(n)**

OR


**Find the largest rectangular area possible in a given histogram where the largest rectangle can be made of a number of contiguous bars. For simplicity, assume that all bars have same width and the width is 1 unit.**
"""

# Python3 program to find maximum rectangular area in linear time O(n)

def max_area_histogram(histogram): 
	
	# This function calulates maximum 
	# rectangular area under given 
	# histogram with n bars 

	# Create an empty stack. The stack 
	# holds indexes of histogram[] list. 
	# The bars stored in the stack are 
	# always in increasing order of 
	# their heights. 
	stack = list() 

	max_area = 0 # Initialize max area 

	# Run through all bars of 
	# given histogram 
	index = 0
	while index < len(histogram): 
		
		# If this bar is higher 
		# than the bar on top 
		# stack, push it to stack 

		if (not stack) or (histogram[stack[-1]] <= histogram[index]): 
			stack.append(index) 
			index += 1

		# If this bar is lower than top of stack, 
		# then calculate area of rectangle with 
		# stack top as the smallest (or minimum 
		# height) bar.'i' is 'right index' for 
		# the top and element before top in stack 
		# is 'left index' 
		else: 
			# pop the top 
			top_of_stack = stack.pop() 

			# Calculate the area with 
			# histogram[top_of_stack] stack 
			# as smallest bar 
			area = (histogram[top_of_stack] *
				((index - stack[-1] - 1) 
				if stack else index)) 

			# update max area, if needed 
			max_area = max(max_area, area) 

	# Now pop the remaining bars from 
	# stack and calculate area with 
	# every popped bar as the smallest bar 
	while stack: 
		
		# pop the top 
		top_of_stack = stack.pop() 

		# Calculate the area with 
		# histogram[top_of_stack] 
		# stack as smallest bar 
		area = (histogram[top_of_stack] *
			((index - stack[-1] - 1) 
				if stack else index)) 

		# update max area, if needed 
		max_area = max(max_area, area) 

	# Return maximum area under 
	# the given histogram 
	return max_area 

# Driver Code 
hist = [6, 2, 5, 4, 5, 1, 6] 
print("Maximum area is", 
	max_area_histogram(hist))

# Python3 program for range minimum 
# query using segment tree 
# modified to return index of minimum instead of minimum itself 
#------------------------------------------------------------------------- 
from math import ceil,log2; 
	
# A utility function to get 
# minimum of two numbers 
def minVal(hist,x, y) : 
	if x==-1: 
		return y 
	if y==-1: 
		return x 
	return x if (hist[x] < hist[y]) else y; 
	
# A utility function to get the 
# middle index from corner indexes. 
def getMid(s, e) : 
	return s + (e - s) // 2; 
	
""" A recursive function to get the 
minimum value in a given range 
of array indexes. The following 
are parameters for this function. 
	
	st --> Pointer to segment tree 
	index --> Index of current node in the 
		segment tree. Initially 0 is 
		passed as root is always at index 0 
	ss & se --> Starting and ending indexes 
				of the segment represented 
				by current node, i.e., st[index] 
	qs & qe --> Starting and ending indexes of query range """
def RMQUtil( hist,st, ss, se, qs, qe, index) : 
	
	# If segment of this node is a part 
	# of given range, then return 
	# the min of the segment 
	if (qs <= ss and qe >= se) : 
		return st[index]; 
	
	# If segment of this node 
	# is outside the given range 
	if (se < qs or ss > qe) : 
		return -1; 
	
	# If a part of this segment 
	# overlaps with the given range 
	mid = getMid(ss, se); 
	return minVal(hist,RMQUtil(hist,st, ss, mid, qs, 
						qe, 2 * index + 1), 
				RMQUtil(hist,st, mid + 1, se, 
						qs, qe, 2 * index + 2)); 
	
# Return minimum of elements in range 
# from index qs (query start) to 
# qe (query end). It mainly uses RMQUtil() 
def RMQ( hist,st, n, qs, qe) : 
	
	# Check for erroneous input values 
	if (qs < 0 or qe > n - 1 or qs > qe) : 
		
		print("Invalid Input"); 
		return -1; 
		
	return RMQUtil(hist,st, 0, n - 1, qs, qe, 0); 
	
# A recursive function that constructs 
# Segment Tree for array[ss..se]. 
# si is index of current node in segment tree st 
def constructSTUtil(hist, ss, se, st, si) : 
	
	# If there is one element in array, 
	# store it in current node of 
	# segment tree and return 
	if (ss == se) : 
	
		st[si] = ss; 
		return st[si]; 
	
	# If there are more than one elements, 
	# then recur for left and right subtrees 
	# and store the minimum of two values in this node 
	mid = getMid(ss, se); 
	st[si] = minVal(hist,constructSTUtil(hist, ss, mid, 
									st, si * 2 + 1), 
					constructSTUtil(hist, mid + 1, se, 
									st, si * 2 + 2)); 
		
	return st[si]; 
	
"""Function to construct segment tree 
from given array. This function allocates 
memory for segment tree and calls constructSTUtil() 
to fill the allocated memory """
def constructST( hist, n) : 
	
	# Allocate memory for segment tree 
	
	# Height of segment tree 
	x = (int)(ceil(log2(n))); 
	
	# Maximum size of segment tree 
	max_size = 2 * (int)(2**x) - 1; 
	
	st = [0] * (max_size); 
	
	# Fill the allocated memory st 
	constructSTUtil(hist, 0, n - 1, st, 0); 
	
	# Return the constructed segment tree 
	return st; 
	

#---------------------------------------------------------------- 

# main program 
# Python3 program using Divide and Conquer 
# to find maximum rectangular area under a histogram in O(nLogn)


def max_area_histogram(hist): 
	area=0
	#initialize area 
	
	st = constructST(hist, len(hist)) 
	# contruct the segment tree 
	
	try: 
		# try except block is generally used in this way 
		# to suppress all type of exceptions raised. 
		
		def fun(left,right): 
			
		# this function "fun" calculates area 
		# recursively between indices left and right 
			
			nonlocal area 
			
			# global area won't work here as 
			# variable area is defined inside function 
			# not in main(). 
			
			if left==right: 
				return
			# the recursion has reached end 
			
			
			index = RMQ(hist,st, len(hist), left, right-1) 
			# RMQ function returns index 
			# of minimum value 
			# in the range of [left,right-1] 
			# can also be found by using min() but 
			# results in O(n) instead of O(log n) for traversing 
			
			area=max(area,hist[index]*(right-left)) 
			# calculate area with minimum above 
			
			fun(index+1,right) 
			fun(left,index) 
			# initiate further recursion 
			
			return
				
		fun(0,len(hist)) 
		# initializes the recursion 
		
		return(area) 
		# return the max area to calling function 
		# in this case "print" 
		
	except: 
		pass
	
# Driver Code 
hist = [6, 2, 5, 4, 5, 1, 6] 
print("Maximum area is", 
	max_area_histogram(hist))

"""# Question 4
**Given a non-negative integer num represented as a string, remove k digits from the number so that the new number is the smallest possible.**
Note:
The length of num is less than 10002 and will be ≥ k.
The given num does not contain any leading zero.

Example 1:

Input: num = "1432219", k = 3

Output: "1219"

Explanation: Remove the three digits 4, 3, and 2 to form the new number 1219 which is the smallest.

Example 2:

Input: num = "10200", k = 1

Output: "200"

Explanation: Remove the leading 1 and the number is 200. Note that the output must not contain leading zeroes.

Example 3:

Input: num = "10", k = 2

Output: "0"

Explanation: Remove all the digits from the number and it is left with nothing which is 0. Note: Time Complexity: O(kn) , where k is the count of numbers to be removed and n is the length of string.

# Algorithm

Initialize result as empty string

     res = ""

buildLowestNumber(str, n, res)

1) If n == 0, then there is nothing to remove. Append the whole 'str' to 'res' and return

2) Let 'len' be length of 'str'. If 'len' is smaller or equal 
   to n, then everything can be removed Append nothing to 'res' and return

3) Find the smallest character among first (n+1) characters
   of 'str'.  Let the index of smallest character be minIndex.
   Append 'str[minIndex]' to 'res' and recur for substring after
   minIndex and for n = n-minIndex

     buildLowestNumber(str[minIndex+1..len-1], n-minIndex).
"""

def removeKdigits(num, k):
    stack = []
    for ch in num:
        while k > 0 and len(stack) > 0 and int(stack[-1]) > int(ch):
            stack.pop()
            k -= 1
        stack.append(ch)
        
    while k > 0:
        stack.pop()
        k -= 1
	
    return "0" if len(stack) ==0 else str(int("".join(stack)))
n=input()
l=int(input())
print(removeKdigits(n, l))